.486
.model flat, stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib

include \masm32\macros\macros.asm

WinMain proto hInst:HINSTANCE, hPrevInst:HINSTANCE, lpCmdLine:DWORD, uCmdShow:DWORD
DlgProc proto hMainDlg:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM
FuncProc proto hdlg:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM
ButtonProc proto hbutton:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM
OptionsProc proto hOptions:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM

CenterWindow proto hdlg:HWND
CreateListView proto hdlg:HWND

.data?
hInstance			HINSTANCE		?
hMainMenu			HMENU			?
hAboutMenu			HMENU			?
hFileMenu			HMENU			?

hList				HWND			?
hMainDlg			HWND			?
hButton				HWND			?

wc					WNDCLASSEX		<>
OldListProc			DWORD			?
OldButtonProc		DWORD			?
BackColor			HBRUSH			?
cxClientSize		WORD			?
cyClientSize		WORD			?

align 8
.data
DlgName				byte		"MAINDLG",0
Column1				byte		"X Value",0
Column2				byte		"f(x)=",0
ClassName			byte		"Class",0
AppName				byte		"App",0
hFunc				HWND		0

.const
MENU_DRAW			equ			1
MDRAW_TABLE			equ			2
MDRAW_GRAPH			equ			3
MABOUT				equ			4
MFILE_EXIT			equ			5

IDC_GRP1						equ 1001
IDC_STC1						equ 1002
IDC_EDT1						equ 1003
IDC_STC2						equ 1010
IDC_EDT2						equ 1004
IDC_STC3						equ 1011
IDC_EDT3						equ 1005
IDC_STC4						equ 1012
IDC_EDT4						equ 1006
IDC_STC5						equ 1013
IDC_EDT5						equ 1007
IDC_STC6						equ 1014
IDC_EDT6						equ 1008
IDC_STC7						equ 1015
IDC_EDT7						equ 1009
IDC_BTN2						equ 2
IDC_BTN3						equ 3
IDC_BTN1						equ 1
.code
start:
	invoke GetModuleHandle,NULL
	mov hInstance, eax
	invoke WinMain, eax, NULL, NULL, SW_SHOWMAXIMIZED
	
	invoke ExitProcess,0
	invoke InitCommonControls

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, lpCmdLine:DWORD, uCmdShow:DWORD
	LOCAL msg:MSG
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET DlgProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL, IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	invoke CreateWindowEx, WS_EX_APPWINDOW, addr ClassName, addr AppName, WS_OVERLAPPED+WS_THICKFRAME+WS_CAPTION+WS_MINIMIZEBOX+WS_SYSMENU+WS_MAXIMIZEBOX, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL 
	mov hMainDlg, eax
	
	invoke ShowWindow, hMainDlg, SW_SHOWMAXIMIZED
	invoke UpdateWindow, hMainDlg
	
	.while TRUE
		invoke GetMessage, addr msg, NULL, NULL, NULL
		.break .if (!eax)
		.if hFunc!=0
			invoke IsDialogMessage, hFunc, addr msg
			.if eax
				.continue
			.endif
		.endif
		invoke TranslateMessage, addr msg
		invoke DispatchMessage, addr msg
	.endw
	
	ret

WinMain endp


DlgProc proc hdlg:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM
	LOCAL rc:RECT
	LOCAL pt:POINT

	.if uMsg==WM_DESTROY
		invoke PostQuitMessage,0
		
	.elseif uMsg==WM_CREATE
		invoke CreateListView, hdlg
		
		invoke CreateDialogParam, hInstance, SADD("FuncDialog"), hdlg, addr FuncProc, NULL
		mov hFunc, eax
		
	;.elseif uMsg==WM_NCHITTEST
	;	invoke DefWindowProc,hdlg, uMsg, wParam, lParam
	;	.if eax==HTCAPTION
	;		mov eax, HTMAXBUTTON
	;		ret
	;	.endif
	;	ret
		
	.elseif uMsg==WM_MOUSEMOVE
		invoke LoadCursor, NULL,IDC_SIZEWE
		invoke SetCursor, eax
		
	.elseif uMsg==WM_SIZE						;LOWORD(lParam)=width HIWORD(lParam)=height
		.if (hList!=0 && hFunc!=0)
			mov eax, lParam
			mov cxClientSize, ax
			shr eax, 16
			mov cyClientSize,ax
			invoke MoveWindow, hList, 0, 0, 250, cyClientSize, TRUE
			
			movzx ebx, cxClientSize
			sub bx, 253
			invoke MoveWindow, hFunc, 253, 0,ebx, cyClientSize,TRUE
		.endif
		
	.else
		invoke DefWindowProc, hdlg, uMsg, wParam, lParam
		ret
	.endif
	
	xor eax, eax
	ret

DlgProc endp

FuncProc proc hdlg:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM
	LOCAL rc:RECT
	
	.if uMsg==WM_CLOSE
		invoke EndDialog, hFunc,0
		mov hFunc, 0
		
	.elseif uMsg==WM_INITDIALOG
		RGB 255,255,255
		invoke CreateSolidBrush,eax
		mov BackColor, eax
		
		invoke CreateWindowEx,WS_EX_STATICEDGE, SADD("Button"), SADD("Edit"),WS_VISIBLE+40008000h, 0, 0, 50, 30, hdlg, NULL, hInstance, NULL
		mov hButton, eax
		invoke SetWindowLong, hButton, GWL_WNDPROC, ButtonProc
		mov OldButtonProc,eax
	.elseif uMsg==WM_CTLCOLORDLG
		mov eax, BackColor
		ret
	.elseif uMsg==WM_SETFOCUS
		invoke SetFocus,hMainDlg
	.elseif uMsg==WM_LBUTTONDOWN
		invoke SetFocus, hMainDlg
	.elseif uMsg==WM_SIZE
		invoke GetClientRect, hFunc, addr rc
		mov eax, rc.bottom
		sub eax, 52
		invoke MoveWindow,hButton, 0, eax, 50, 25, TRUE
	
	.elseif uMsg==WM_COMMAND
		mov eax, wParam
		shr eax, 16
		.if eax==BN_CLICKED
			mov ecx, lParam
			.if ecx==hButton
				invoke DialogBoxParam, hInstance, SADD("OptionsDlg"), hMainDlg, addr OptionsProc, 0
			.endif
		.endif
			
	.else
		xor eax, eax
		ret
	.endif
	
	mov eax, TRUE
	ret

FuncProc endp

ButtonProc proc hbutton:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM
	LOCAL pt:POINT
	
	.if uMsg==WM_LBUTTONUP
		;invoke SetFocus, hMainDlg
	.endif
	invoke CallWindowProc, OldButtonProc, hbutton, uMsg, wParam, lParam
	ret

ButtonProc endp

align 4
.data?
hXMin			HWND		?
hXMax			HWND		?
hYMin			HWND		?
hYMax			HWND		?
hDeltaX			HWND		?
hDeltaY			HWND		?
hEditFunc		HWND		?
btApply			HWND		?
btPreview		HWND		?
btCancel		HWND		?

XMin			DWORD		?
XMax			DWORD		?
YMin			DWORD		?
YMax			DWORD		?
DeltaX			DWORD		?
DeltaY			DWORD		?
strFunc			byte		200 dup(?)			

.data
zero			byte		"0",0	
.code

OptionsProc proc hOptions:HWND, uMsg:DWORD, wParam:WPARAM, lParam:LPARAM

	.if uMsg==WM_CLOSE
		invoke SetFocus, hMainDlg
		invoke EndDialog, hOptions, 0
		
	.elseif uMsg==WM_INITDIALOG
		invoke GetDlgItem,hEditFunc, IDC_EDT1
		mov hEditFunc, eax
		invoke GetDlgItem, hOptions, IDC_EDT2
		mov hXMin, eax
		invoke GetDlgItem, hOptions, IDC_EDT3
		mov hXMax, eax
		invoke GetDlgItem, hOptions, IDC_EDT4
		mov hYMin, eax
		invoke GetDlgItem, hOptions, IDC_EDT5
		mov hYMax, eax
		invoke GetDlgItem, hOptions, IDC_EDT6
		mov hDeltaX, eax
		invoke GetDlgItem, hOptions, IDC_EDT7
		mov hDeltaY,eax
		invoke GetDlgItem, hOptions, IDC_BTN1
		mov btApply, eax
		invoke GetDlgItem, hOptions, IDC_BTN2
		mov btPreview, eax
		invoke GetDlgItem, hOptions, IDC_BTN3
		mov btCancel, eax
		
		invoke SetDlgItemText,hOptions, IDC_EDT2, addr zero
		invoke SetDlgItemText,hOptions, IDC_EDT3, addr zero
		invoke SetDlgItemText,hOptions, IDC_EDT4, addr zero
		invoke SetDlgItemText,hOptions, IDC_EDT5, addr zero
		invoke SetDlgItemText,hOptions, IDC_EDT6, addr zero
		invoke SetDlgItemText,hOptions, IDC_EDT7, addr zero
		
	.elseif uMsg==WM_COMMAND
		mov eax, wParam
		shr eax, 16
		.if eax==BN_CLICKED
			mov eax, lParam
			.if eax==btApply
				invoke GetDlgItemText, hOptions, IDC_EDT1, addr strFunc, sizeof strFunc -1
				
				
			.elseif eax==btCancel
				invoke SendMessage, hOptions, WM_CLOSE, 0, 0
			.endif
		.endif
		
	.else
		mov eax, FALSE
		ret
	.endif
	
	mov eax, TRUE
	ret

OptionsProc endp

CreateListView proc hdlg:HWND
	LOCAL lv:LV_COLUMN
	
	invoke CreateWindowEx,NULL, SADD("SysListView32"), NULL, WS_VISIBLE+LVS_REPORT + WS_CHILD + LVS_SHOWSELALWAYS, 0, 0, 0, 0, hdlg, NULL,hInstance, NULL
	mov hList, eax
	
	mov lv.imask, LVCF_TEXT or LVCF_WIDTH
	mov lv.lx, 125
	mov lv.pszText, offset Column2
	invoke SendMessage, hList, LVM_INSERTCOLUMN, 0, addr lv
	mov lv.pszText, offset Column1
	invoke SendMessage, hList, LVM_INSERTCOLUMN, 0, addr lv
	
	invoke SendMessage,hList,LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT + LVS_EX_GRIDLINES + LVS_EX_HEADERDRAGDROP,LVS_EX_GRIDLINES + LVS_EX_FULLROWSELECT + LVS_EX_HEADERDRAGDROP 

	ret
CreateListView endp

CenterWindow proc hdlg:HWND
	LOCAL pt:POINT
	LOCAL rc:RECT
	
	invoke GetSystemMetrics,SM_CXSCREEN
	mov pt.x, eax
	invoke GetSystemMetrics,SM_CYSCREEN
	mov pt.y,eax
	invoke GetClientRect, hdlg, addr rc
	mov eax, pt.y
	shr eax, 1
	mov ebx, rc.bottom
	shr ebx, 1
	sub eax, ebx
	mov pt.y, eax
	mov eax, pt.x
	shr eax, 1
	mov ebx, rc.right
	shr ebx, 1
	sub eax, ebx
	mov pt.x, eax
	invoke SetWindowPos, hdlg, HWND_NOTOPMOST, pt.x, pt.y, 0, 0, SWP_NOSIZE
	ret
	
CenterWindow endp

end start